require 'collision'
-- d=√((x 2  – x 1)² + (y 2  – y 1)²)
function dist(x1, y1, x2, y2)
    return math.sqrt((x2 - x1)^2 + (y2 - y1)^2)
end

function Single_Ray(orig_x, orig_y, dir, orig_dir, speed, map, dists, xs, ys, objs)
    local sin_a = math.sin(math.rad(dir))
    local cos_a = math.cos(math.rad(dir))
    local ray_x = orig_x
    local ray_y = orig_y
    local dist_amount = 0
    local table_dists = {}
    local table_xs = {}
    local table_ys = {}
    local table_objs = {}
    for i = 1, 500 / speed do
        ray_x = ray_x + cos_a * speed
        ray_y = ray_y - sin_a * speed
        for k,v in pairs(map) do
            if aabb(ray_x, ray_y, 1, 1, v.x, v.y, v.w, v.h) then
                table.insert(table_dists, #table_dists + 1, dist(ray_x, ray_y, orig_x, orig_y) * math.cos(math.rad(orig_dir) - math.rad(dir)))
                table.insert(table_xs, #table_xs + 1, ray_x)
                table.insert(table_ys, #table_ys + 1, ray_y)
                table.insert(table_objs, #table_objs + 1, v)
            end
        end
    end
    return table_dists, table_xs, table_ys, table_objs
end

function Ray_Plain(orig_x, orig_y, dir, orig_dir, speed, map, dists, xs, ys, objs, RES, FOV)
    local dir_new = dir + (FOV / 2)
    local dist_t = {}
    local xs_t = {}
    local ys_t = {}
    local obj_t = {}
    for i = 1, FOV / RES do
        dir_new = dir_new - RES
        dist_t, xs_t, ys_t, obj_t = Single_Ray(orig_x, orig_y, dir_new, orig_dir, speed, map, dists, xs, ys, objs)
        table.insert(dists, #dists + 1, dist_t)
        table.insert(xs, #xs + 1, xs_t)
        table.insert(ys, #ys + 1, ys_t)
        table.insert(objs, #objs + 1, obj_t)
    end
end